/*
 * NeXFontSel
 *
 * YOKOTA Hiroshi <yokota@netlab.is.tsukuba.ac.jp>
 */

/* $Id: nexfontsel.h,v 1.1 1999/05/15 16:38:53 elca Exp $ */

#ifndef _NEXFONTSEL_H
#define _NEXFONTSEL_H

#define DEFAULTPATTERN "-*-*-*-*-*-*-*-*-*-*-*-*-*-*"

#define MIN_APP_DEFAULTS_VERSION 1
#define FIELD_COUNT 14
#define DELIM '-'

/* number of font names to parse in each background iteration */
#ifndef PARSE_QUANTUM
#define PARSE_QUANTUM 25
#endif

#define BACKGROUND 10

/* from X11/IntrinsicP.h */
typedef void (*XtProc)(/*void*/);

typedef enum {ValidateCurrentField, SkipCurrentField} ValidateAction;

typedef struct FieldValue FieldValue;
struct FieldValue {
	int field;
	String string;
	Widget menu_item;
	int count;	     /* of fonts */
	int allocated;
	int *font;
	Boolean enable;
};


typedef struct FieldValueList FieldValueList;
struct FieldValueList {
	int count;		/* of values */
	int allocated;
	Boolean show_unselectable;
	FieldValue value[1];	/* really [allocated] */
};

typedef struct FontValues FontValues;
struct FontValues {
	int value_index[FIELD_COUNT];
};

typedef struct FieldMenuRec FieldMenuRec;
struct FieldMenuRec {
	int field;
	Widget button;
};

typedef struct Choice Choice;
struct Choice {
	Choice *prev;
	FieldValue *value;
};


void ScheduleWork(XtProc proc, XtPointer closure, int priority);
void SetNoFonts(void);
void SetParsingFontCount(int count);
void SetCurrentFontCount(void);
void EnableRemainingItems(ValidateAction current_field_action);
void EnableAllItems(int field);
void FlushXqueue(Display *dpy);
void MarkInvalidFonts(Boolean *set, FieldValue *val);
void AllAnyValue(Widget w, XtPointer closure, XtPointer callData);

#endif
/* end */
